<template>
	<v-app id="inspire">
		<v-navigation-drawer v-model="drawer" app clipped color="accent" dark>
			<v-list dense>
				<template v-for="[title, icon, route, permission, external] of items">
					<NavListItem :key="title + permission" v-bind="{title, icon, route, external}"/>
				</template>
				<!-- <NavListItem title="Project website" icon="public" :external=true route="https://erasmus.tssteinfurt.de/">
					<v-icon>launch</v-icon>
				</NavListItem> -->
			</v-list>
		</v-navigation-drawer>

		<v-app-bar app clipped-left>
			<v-btn
				icon
				id="menu"
				@click.stop="drawer = !drawer"
				><v-icon large>menu</v-icon></v-btn
			>
			<!-- <v-app-bar-nav-icon x-large @click.stop="drawer = !drawer" color="primary"/> -->
			<router-link
				to="/"
				exact
				class="primary--text home"
			>
				<v-tooltip bottom>
					<span>Homepage</span>
					<template v-slot:activator="{ on, attrs }">
						<v-layout align-center v-bind="attrs" v-on="on">
							<span class="d-none d-sm-block">EUPRONET</span>
							<img
								src="./assets/i40.png"
								align="center"
								height="35px"
								:style="logo_filter"
							/>
						</v-layout>
					</template>
				</v-tooltip>
			</router-link>
			<v-spacer/>
			<v-breadcrumbs divider="/" v-if="!this.$store.getters.loggedIn">
				<v-breadcrumbs-item v-bind:to="'/login'">	Log in	</v-breadcrumbs-item>
				<v-breadcrumbs-item v-bind:to="'/register'">Sign up	</v-breadcrumbs-item>
			</v-breadcrumbs>
			<span class="status" v-else>Logged in as {{this.$store.state.username}}</span>
			<v-menu  :nudge-bottom=70 :close-on-content-click="false" v-model="accountMenu" transition="slide-y-transition">
				<template v-slot:activator="{ on, attrs }">
					<v-avatar color="primary">
						<v-btn fab v-bind="attrs" v-on="on" color="secondary">
							<v-icon dark size="50">account_circle</v-icon>
						</v-btn>
					</v-avatar>
				</template>
				<AccountMenu @close="accountMenu=false"/>
			</v-menu>
		</v-app-bar>

		<v-main>
			<router-view></router-view>
		</v-main>
		<v-footer
			absolute
			inset
			app
			color="primary--text"
			id="footer"
		>
			<span>&copy; {{year}} Déri Miksa</span>
		</v-footer>
	</v-app>
</template>

<style>

html, body {
	overflow-y: auto;
}

.splitpanes__splitter {background-color: #ccc;position: relative;}
.splitpanes__splitter:before {
  content: '';
  position: absolute;
  left: 0;
  top: 0;
  transition: opacity 0.4s;
  background-color: #a0b9d677;
  opacity: 0;
  z-index: 1;
}
.splitpanes__splitter:hover:before {opacity: 1;}
.splitpanes--vertical > .splitpanes__splitter:before {left: -10px;right: -10px;height: 100%;}
.splitpanes--horizontal > .splitpanes__splitter:before {top: -10px;bottom: -10px;width: 100%;}

</style>

<style scoped>
.status{
	padding: 0.75em;
}
.home{
	cursor: pointer; 
	font-weight: bold;
	font-size: 25pt;
	text-decoration: none;
}
#menu{
	width:60px;
	height:60px;
	color:var(--v-primary-base);
}
#footer{
	font-weight : bold;
	font-style: italic;
	font-size: 12pt;
}
</style>

<script>
/* import Home from './views/Home'; */
import NavListItem from './components/NavListItem'
import AccountMenu from './components/AccountMenu'
import { httpGet } from './utils/connection';
export default {
	name: "App",
	
	components: {	
		NavListItem,
		AccountMenu
	},

	data: () => ({
		drawer: false,
		accountMenu: false,
		navItems: [
			["Store", 	"mdi-basket", "/store", -1],
			["My orders", 	"mdi-cart", "/orders", -1],
			["Metrics", "mdi-chart-box", "/metrics", -1],
			["Dashboard", "mdi-cog", "/dashboard", 7],
			["Project website", "mdi-earth", "https://erasmus.tssteinfurt.de/", -1, true]
		]
	}),
	mounted(){
        this.$vuetify.theme.dark = this.$store.state.dark;
		this.$store.dispatch("get_permission");
    },
	methods: {
		// async isSufficient(permission) {
		// 	if (permission === -1) return true;

		// 	let response = await httpGet(`${process.env.VUE_APP_API_URL}/permissionlevel`);
		// 	return response && response.permission >= permission;
		// }
	},
	computed: {
		logo_filter() {
			return this.$store.state.dark ? 
			"filter: invert(78%) sepia(39%) saturate(322%) hue-rotate(182deg) brightness(90%) contrast(85%);" :
			"filter: invert(14%) sepia(26%) saturate(3919%)hue-rotate(208deg) brightness(91%) contrast(86%)"
		},
		items() {
			let res = this.navItems.filter((item) => {
				let permission = item[3];

				return this.$store.state.permission >= permission;
			});

			return res;
		},
		year() {
			return new Date().getFullYear();
		}
	},
};
</script>
